@REM ***************************************************************************
@REM *
@REM * Licensed Materials - Property of IBM
@REM * 5698-A17
@REM *
@REM * (C) Copyright IBM Corp. 1990, 2009.  All Rights Reserved.
@REM *
@REM * US Government Users Restricted Rights - Use, duplication or
@REM * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
@REM *
@REM ***************************************************************************
@REM *
@echo off
setlocal
set local_dir=%cd%

if exist "%local_dir%\ParseAndRep_rFile.tmp" del /q /f "%local_dir%\ParseAndRep_rFile.tmp"
if exist "%local_dir%\ParseAndRep_iFile.tmp" del /q /f "%local_dir%\ParseAndRep_iFile.tmp"
if exist "%local_dir%\ParseAndRep_xFile.tmp" del /q /f "%local_dir%\ParseAndRep_xFile.tmp"
if {%2}=={} goto err1
if not exist %1 goto err2
if not exist %2 goto err3
set iFile=%1
set rFile=%2
set VALOK=Y
set pCode=[NO]
set pLine=[NO]
set bypass=*#$[ParseAndRep_BYPASS]$#*
set insert=*#$[ParseAndRep_INSERT]$#*
call convcntl %rFile% "%local_dir%\ParseAndRep_rFile.tmp"
for /f "Tokens=*" %%r in ('type "%local_dir%\ParseAndRep_rFile.tmp"') do (
 set rLine=%%r
 call :VALrLine
)
if "%VALOK%" EQU "N" goto finish
call convcntl %iFile% "%local_dir%\ParseAndRep_iFile.tmp"
for /f "Tokens=1* Delims=:" %%a in ('type "%local_dir%\ParseAndRep_iFile.tmp"^|Findstr /l /n /v /c:"[[*$]]"') do (
 set iLine=%%b
 call :REPiLine
) 
if "%VALOK%" EQU "N" goto finish
del /f /q %iFile%
call convcntl "%local_dir%\ParseAndRep_xFile.tmp" %iFile% /U
del /q /f "%local_dir%\ParseAndRep_xFile.tmp"
:finish
if exist "%local_dir%\ParseAndRep_rFile.tmp" del /q /f "%local_dir%\ParseAndRep_rFile.tmp"
if exist "%local_dir%\ParseAndRep_iFile.tmp" del /q /f "%local_dir%\ParseAndRep_iFile.tmp"
endlocal
goto :EOF
:REPiLine
if "%iLine%" EQU "" goto REPiLO
set FND=N
for /f "Tokens=*" %%r in ('type "%local_dir%\ParseAndRep_rFile.tmp"') do (
 set rLine=%%r
 call :find
)
if "%iLine%" EQU "%bypass%" goto :EOF
if "%iLine%" EQU "" goto REPiLO
(
@echo %iLine%
)>>"%local_dir%\ParseAndRep_xFile.tmp"
goto :EOF
:REPiLO
(
@echo.
)>>"%local_dir%\ParseAndRep_xFile.tmp"
goto :EOF
:find
if "%FND%" EQU "Y" goto findY
if "%iLine%" EQU "%bypass%" goto :EOF
if /i "%rLine:~0,4%" EQU "[ST]" goto RST
if /i "%rLine:~0,4%" EQU "[RT]" goto :EOF
if /i "%rLine:~0,4%" EQU "[FB]" goto RFB
if /i "%rLine:~0,4%" EQU "[FE]" goto RFE
if /i "%rLine:~0,4%" EQU "[IB]" goto :EOF
if /i "%rLine:~0,4%" EQU "[IC]" goto :RIC
if /i "%rLine:~0,4%" EQU "[IE]" goto :EOF
:errl
@echo ParseAndRep - Invalid ParseAndRep logic.
set VALOK=N
endlocal
goto :EOF
:findY
if /i "%rLine:~0,4%" EQU "[ST]" goto :EOF
if /i "%rLine:~0,4%" EQU "[RT]" goto RRT
if /i "%rLine:~0,4%" EQU "[FB]" goto :EOF
if /i "%rLine:~0,4%" EQU "[FE]" goto RFE
if /i "%rLine:~0,4%" EQU "[IB]" goto RIB
if /i "%rLine:~0,4%" EQU "[IC]" goto :RIC
if /i "%rLine:~0,4%" EQU "[IE]" goto RIE
goto errl
:RST
if "%iLine%" EQU "%bypass%" goto :EOF
call set ans=%%iLine:%rLine:~4%=%%
if "%ans%" EQU "%iLine%" goto :EOF
set FND=Y
set pLine=%rLine%
goto :EOF
:RRT
if "%iLine%" EQU "%bypass%" goto :EOF
if /i "%pLine:~0,4%" NEQ "[ST]" goto :EOF
call set iLine=%%iLine:%pLine:~4%=%rLine:~4%%%
set FND=N
set pLine=%rLine%
goto :EOF
:RFB
if "%iLine%" EQU "%bypass%" goto :EOF
call set ans=%%iLine:%rLine:~4%=%%
if "%ans%" EQU "%iLine%" goto :EOF
set FND=Y
set iLine=%bypass%
set pLine=%rLine%
goto :EOF
:RFE
if "%iLine%" EQU "%bypass%" goto :EOF
call set ans=%%iLine:%rLine:~4%=%%
if "%ans%" EQU "%iLine%" goto :RFEX
set FND=Y
set iLine=%bypass%
set pLine=%rLine%
goto :EOF
:RFEX
if /i "%pLine:~0,4%" NEQ "[FB]" goto :EOF
set iLine=%bypass%
goto :EOF
:RIB
if /i "%pLine:~0,4%" EQU "[IC]" goto RIBX
if /i "%pLine:~0,4%" NEQ "[FE]" goto :EOF
:RIBX
if "%rLine:~4%" EQU "" goto RIX
(
@echo %rLine:~4%
)>>"%local_dir%\ParseAndRep_xFile.tmp"
goto :EOF
:RIC
if "%iLine%" EQU "%bypass%" goto :EOF
call set ans=%%iLine:%rLine:~4%=%%
if "%ans%" EQU "%iLine%" goto :EOF
set FND=Y
set pLine=%rLine%
if "%iLine%" EQU "" goto RICX
(
@echo %iLine%
)>>"%local_dir%\ParseAndRep_xFile.tmp"
set iLine=%bypass%
goto :EOF
:RICX
(
@echo.
)>>"%local_dir%\ParseAndRep_xFile.tmp"
set iLine=%bypass%
goto :EOF
:RIE
if /i "%pLine:~0,4%" EQU "[IC]" goto RIEX
if /i "%pLine:~0,4%" NEQ "[FE]" goto :EOF
:RIEX
set FND=N
set pLine=%rLine%
if "%rLine:~4%" EQU "" goto RIX
(
@echo %rLine:~4%
)>>"%local_dir%\ParseAndRep_xFile.tmp"
goto :EOF
:RIX
(
@echo.
)>>"%local_dir%\ParseAndRep_xFile.tmp"
goto :EOF
:VALrLine
if /i "%rLine:~0,4%" EQU "[ST]" goto VST
if /i "%rLine:~0,4%" EQU "[RT]" goto VRT
if /i "%rLine:~0,4%" EQU "[FB]" goto VFB
if /i "%rLine:~0,4%" EQU "[FE]" goto VFE
if /i "%rLine:~0,4%" EQU "[IB]" goto VIB
if /i "%rLine:~0,4%" EQU "[IC]" goto VIC
if /i "%rLine:~0,4%" EQU "[IE]" goto VIE
:errx
@echo ParseAndRep - Invalid rFile ParseAndRepment coding.
set VALOK=N
endlocal
goto :EOF
:VALe
set pCode=%rLine:~0,4%
goto :EOF
:VST
if /i "%pCode%" EQU "[ST]" goto errx
if /i "%pCode%" EQU "[IB]" goto errx
if /i "%pCode%" EQU "[FB]" goto errx
if /i "%pCode%" EQU "[IC]" goto errx
goto VALe
:VRT
if /i "%pCode%" EQU "[ST]" goto VALe
goto errx
:VFB
if /i "%pCode%" EQU "[ST]" goto errx
if /i "%pCode%" EQU "[IB]" goto errx
goto VALe
:VFE
if /i "%pCode%" EQU "[FB]" goto VALe
if /i "%pCode%" EQU "[ST]" goto errx
if /i "%pCode%" EQU "[IB]" goto errx
goto VALe
:VIB
if /i "%pCode%" EQU "[IB]" goto VALe
if /i "%pCode%" EQU "[IC]" goto VALe
if /i "%pCode%" NEQ "[FE]" goto errx
goto VALe
:VIC
if /i "%pCode%" EQU "[ST]" goto errx
if /i "%pCode%" EQU "[IB]" goto errx
if /i "%pCode%" EQU "[FB]" goto errx
goto VALe
:VIE
if /i "%pCode%" EQU "[IB]" goto VALe
if /i "%pCode%" EQU "[IC]" goto VALe
if /i "%pCode%" NEQ "[FE]" goto errx
goto VALe
:err1
@echo Syntax: ParseAndRep iFile rFile
endlocal
goto :EOF
:err2
@echo ParseAndRep - %1 NOT found.
endlocal
goto :EOF
:err3
@echo ParseAndRep - %2 NOT found.
endlocal
